'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Accordion = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAnimateHeight = require('react-animate-height');

var _reactAnimateHeight2 = _interopRequireDefault(_reactAnimateHeight);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * The CivicPlus accordion container.
 */
var Accordion = exports.Accordion = function (_Component) {
	_inherits(Accordion, _Component);

	function Accordion(props) {
		_classCallCheck(this, Accordion);

		var _this = _possibleConstructorReturn(this, (Accordion.__proto__ || Object.getPrototypeOf(Accordion)).call(this, props));

		_this.handleOpen = function (openEvent) {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.render = function () {
			return _react2.default.createElement(
				'div',
				{ className: 'accordionWrap' },
				_react2.default.createElement(
					'h4',
					{ id: _this.props.id || '', className: 'cp-AccordionControl cp-AccordionControl--minor ' + (_this.state.isOpen ? 'is-open' : ''), onClick: _this.handleOpen },
					_this.props.title,
					_react2.default.createElement(
						'svg',
						{ className: 'cp-AccordionControl-arrow' },
						_react2.default.createElement('use', { xmlnsXlink: 'http://www.w3.org/1999/xlink', xlinkHref: '#iconArrow--right' })
					)
				),
				_react2.default.createElement(
					_reactAnimateHeight2.default,
					{
						duration: 360,
						height: _this.state.isOpen ? 'auto' : '0',
						className: 'cp-AccordionContainer ' + (_this.state.isOpen ? 'is-open' : '')
					},
					_this.props.children
				)
			);
		};

		_this.state = {
			isOpen: _this.props.open
		};
		return _this;
	}

	return Accordion;
}(_react.Component);

Accordion.propTypes = {
	/** isOpen sets the standard state of the accordion */
	isOpen: _propTypes2.default.bool
};
Accordion.defaultProps = {
	isOpen: false
};
exports.default = Accordion;