'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ActionMenu = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('./../Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActionMenu = exports.ActionMenu = function (_Component) {
	_inherits(ActionMenu, _Component);

	function ActionMenu(props) {
		_classCallCheck(this, ActionMenu);

		var _this = _possibleConstructorReturn(this, (ActionMenu.__proto__ || Object.getPrototypeOf(ActionMenu)).call(this, props));

		_this.handleOpen = function (openEvent) {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.render = function () {
			var id = _this.props.id;
			var isOpen = _this.state.isOpen;


			return _react2.default.createElement(
				'div',
				{ id: id,
					ref: _this.setWrapperRef,

					className: 'cp-ActionMenu-holder ' + (isOpen ? 'has-actionMenuOpen' : ''),
					'data-label': 'Actions' },
				_react2.default.createElement(
					'button',
					{ className: 'cp-ActionMenu-btn cp-OpenActionMenu ' + (isOpen ? 'is-open' : ''),
						onClick: _this.handleOpen,
						tabIndex: '0' },
					_react2.default.createElement(
						'svg',
						{ className: 'cp-ActionMenu-icon' },
						_react2.default.createElement('use', { xlinkHref: '#iconTools' })
					),
					_react2.default.createElement(
						'span',
						{ className: 'cp-ActionMenu-text' },
						'Actions'
					),
					_react2.default.createElement(
						'svg',
						{ className: 'cp-ActionMenu-arrow' },
						_react2.default.createElement('use', { xlinkHref: '#iconArrow--down' })
					)
				),
				_this.renderMenu()
			);
		};

		_this.renderMenu = function () {
			var _this$props = _this.props,
			    id = _this$props.id,
			    options = _this$props.options,
			    transitionTimeout = _this$props.transitionTimeout;
			var isOpen = _this.state.isOpen;

			var transitionProps = { in: isOpen, timeout: transitionTimeout };
			var setState = function setState(isOpen) {
				_this.setState({ isOpen: isOpen });
			};

			var optionDivs = options.map(function (option, index) {
				var optionId = id + 'Option' + index;
				var optionProps = {
					className: 'cp-ActionMenu-' + option.text,
					id: optionId
				};

				// prioritize url
				if (option.url) {
					optionProps.href = option.url;
				} else if (option.action) {
					optionProps.onClick = function () {
						setState(false);
						option.action();
					};
				}

				return _react2.default.createElement(
					'li',
					{ key: index },
					_react2.default.createElement(
						_Button2.default,
						_extends({ noStyles: true }, optionProps),
						option.text
					)
				);
			});

			return _react2.default.createElement(
				_Transition2.default,
				transitionProps,
				function (state) {
					return _react2.default.createElement(
						'ul',
						{ className: 'cp-ActionMenu ActionMenu-fade-' + state },
						optionDivs
					);
				}
			);
		};

		_this.state = {
			isOpen: false
		};

		_this.setWrapperRef = _this.setWrapperRef.bind(_this);
		_this.handleClickOutside = _this.handleClickOutside.bind(_this);
		_this.handleTabOutside = _this.handleTabOutside.bind(_this);
		_this.renderMenu = _this.renderMenu.bind(_this);
		return _this;
	}

	_createClass(ActionMenu, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.addEventListener('mousedown', this.handleClickOutside);
			document.addEventListener('keyup', this.handleTabOutside);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			document.removeEventListener('mousedown', this.handleClickOutside);
			document.removeEventListener('keyup', this.handleTabOutside);
		}
	}, {
		key: 'setWrapperRef',
		value: function setWrapperRef(node) {
			this.wrapperRef = node;
		}
	}, {
		key: 'handleClickOutside',
		value: function handleClickOutside(event) {
			if (this.state.isOpen && this.wrapperRef && !this.wrapperRef.contains(event.target)) {
				this.setState({ isOpen: false });
			}
		}
	}, {
		key: 'handleTabOutside',
		value: function handleTabOutside(event) {
			if (this.state.isOpen && this.wrapperRef && !this.wrapperRef.contains(event.target)) {
				this.setState({ isOpen: false });
			}
		}
	}]);

	return ActionMenu;
}(_react.Component);

ActionMenu.propTypes = {
	/** isOpen sets the standard state of the ActionMenu dropdown */
	isOpen: _propTypes2.default.bool,
	/** options sets the choices presented in the ActionMenu dropdown */
	options: _propTypes2.default.array.isRequired,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({ enter: _propTypes2.default.number, exit: _propTypes2.default.number }), _propTypes2.default.number])
};
ActionMenu.defaultProps = {
	transitionTimeout: 240,
	onChange: function onChange(e) {}
};
exports.default = ActionMenu;