'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CPTable = exports.CPTableTemplates = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Column = require('../Column/Column');

var _DataTable = require('../DataTable/DataTable');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CPTableTemplates = exports.CPTableTemplates = function () {
    function CPTableTemplates() {
        _classCallCheck(this, CPTableTemplates);
    }

    _createClass(CPTableTemplates, null, [{
        key: 'headerTemplate',
        value: function headerTemplate(column, sorted, sortOrder) {
            if (column.sortable) {
                var className = (0, _classnames2.default)('cp-Btn--sort-holder', sorted ? sortOrder < 0 ? 'is-down is-active' : 'is-up is-active' : 'is-down');

                return _react2.default.createElement(
                    'span',
                    null,
                    column.headerText,
                    _react2.default.createElement(
                        'span',
                        { className: className },
                        _react2.default.createElement(
                            'button',
                            { className: 'cp-Btn cp-Btn--sort cp-Btn--sort-up', title: "Sort by " + column.headerText + ", in ascending order" },
                            _react2.default.createElement(
                                'svg',
                                { className: 'ui-sortable-column-icon' },
                                _react2.default.createElement('use', { xlinkHref: '#iconArrow--up' })
                            )
                        ),
                        _react2.default.createElement(
                            'button',
                            { className: 'cp-Btn cp-Btn--sort cp-Btn--sort-down', title: "Sort by " + column.headerText + ", in descending order" },
                            _react2.default.createElement(
                                'svg',
                                { className: 'ui-sortable-column-icon' },
                                _react2.default.createElement('use', { xlinkHref: '#iconArrow--down' })
                            )
                        )
                    )
                );
            } else {
                return _react2.default.createElement(
                    'span',
                    null,
                    column.headerText
                );
            }
        }
    }]);

    return CPTableTemplates;
}();

var CPTable = exports.CPTable = function (_Component) {
    _inherits(CPTable, _Component);

    function CPTable(props) {
        _classCallCheck(this, CPTable);

        return _possibleConstructorReturn(this, (CPTable.__proto__ || Object.getPrototypeOf(CPTable)).call(this, props));
    }

    _createClass(CPTable, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _DataTable.DataTable,
                _extends({ tableClassName: 'cp-Tbl' }, this.props),
                this.props.children
            );
        }
    }]);

    return CPTable;
}(_react.Component);

exports.default = CPTable;