'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FileDragAndDrop = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	Based on: https://github.com/paramaggarwal/react-dropzone
*/

var FileDragAndDrop = exports.FileDragAndDrop = function (_Component) {
	_inherits(FileDragAndDrop, _Component);

	function FileDragAndDrop() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FileDragAndDrop);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FileDragAndDrop.__proto__ || Object.getPrototypeOf(FileDragAndDrop)).call.apply(_ref, [this].concat(args))), _this), _this.getInitialState = function () {
			return {
				isDragActive: false
			};
		}, _this.onDragLeave = function () {
			_this.setState({
				isDragActive: false
			});
		}, _this.onDragOver = function (e) {
			e.preventDefault();
			e.dataTransfer.dropEffect = 'copy';
			_this.setState({
				isDragActive: true
			});
		}, _this.onDrop = function (e) {
			e.preventDefault();

			_this.setState({
				isDragActive: false
			});

			var files;
			if (e.dataTransfer) {
				files = e.dataTransfer.files;
			} else if (e.target) {
				files = e.target.files;
			}

			if (_this.props.onDrop) {
				files = Array.prototype.slice.call(files);
				_this.props.onDrop(files);
			}
		}, _this.onClick = function () {
			_this.refs.fileInput.click();
		}, _this.render = function () {
			var className = (0, _classnames2.default)('FileDragAndDrop', {
				'active': _this.state.isDragActive
			}, _this.props.className);
			return _react2.default.createElement(
				'button',
				{ className: className, type: 'button', onClick: _this.onClick, onDragLeave: _this.onDragLeave, onDragOver: _this.onDragOver, onDrop: _this.onDrop },
				_react2.default.createElement('input', { style: { display: 'none' }, type: 'file', multiple: true, ref: 'fileInput', onChange: _this.onDrop }),
				_react2.default.createElement(
					'div',
					{ className: 'FileDragAndDrop__label' },
					_this.state.isDragActive ? _this.props.labelActive : _this.props.label
				),
				_this.props.children
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return FileDragAndDrop;
}(_react.Component);

FileDragAndDrop.propTypes = {
	className: _propTypes2.default.string,
	label: _propTypes2.default.string,
	labelActive: _propTypes2.default.string,
	onDrop: _propTypes2.default.func.isRequired
};
FileDragAndDrop.defaultProps = {
	label: 'Drag Files Here',
	labelActive: 'Drop to Upload'
};
exports.default = FileDragAndDrop;