'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Filter = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Filter = exports.Filter = function (_Component) {
	_inherits(Filter, _Component);

	function Filter(props) {
		_classCallCheck(this, Filter);

		var _this = _possibleConstructorReturn(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

		_this.handleOpen = function (openEvent) {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.handleSelection = function (selectionEvent) {
			_this.setState({
				isOpen: false
			}, _this.props.onChange(selectionEvent));
		};

		_this.render = function () {
			var id = _this.props.id;
			var _this$state = _this.state,
			    isOpen = _this$state.isOpen,
			    dropdownLabel = _this$state.dropdownLabel;


			return _react2.default.createElement(
				'div',
				{ className: 'cp-FormField cp-FormField--multi' },
				_react2.default.createElement(
					'h4',
					{ className: 'cp-FormField-label cp-FormField-label--multi is-hiddenAt--medium+' },
					'Filter'
				),
				_react2.default.createElement(
					'div',
					{ className: 'cp-FormField-holder cp-FormField-holder--multi' },
					_react2.default.createElement(
						'div',
						{ id: id,
							tabIndex: '0',
							className: 'cp-DropdownMenu ' + (isOpen ? 'is-open' : ''),
							'data-label': dropdownLabel,
							onClick: _this.handleOpen },
						_react2.default.createElement(
							'svg',
							{ className: 'cp-DropdownMenu-arrow--down' },
							_react2.default.createElement('use', { xmlnsXlink: 'http://www.w3.org/1999/xlink', xlinkHref: '#iconArrow--down' })
						),
						_this.renderMenu(_this.handleSelection)
					)
				)
			);
		};

		_this.renderMenu = function (handleSelection) {
			var _this$props = _this.props,
			    id = _this$props.id,
			    transitionTimeout = _this$props.transitionTimeout;
			var isOpen = _this.state.isOpen;

			var transitionProps = { in: isOpen, timeout: transitionTimeout };

			return _react2.default.createElement(
				_Transition2.default,
				transitionProps,
				function (state) {
					return (
						// <div className={`cp-DropdownMenu-menu Dropdown-fade-${state}`}>
						// 	<div className="cp-DropdownMenu-menuSection">
						// 		<div className="cp-FormField cp-FormField--single cp-FormField--minor">
						// 			<label for="displayCategories--user" className="cp-FormField-label cp-FormField-label--single cp-FormField-label--minor">User</label>
						// 			<div className="cp-FormField-holder">
						// 				<input id="displayCategories--user" name="displayCategories--user" type="text" className="cp-FormField-input" />
						// 			</div>
						// 		</div>
						// 	</div>
						// 	<div className="cp-DropdownMenu-menuSection">
						// 		<div className="cp-FormField cp-FormField--minor cp-FormField--single">
						// 			<label for="txtDisplayCategories--dateFrom" className="cp-FormField-label cp-FormField-label--single cp-FormField-label--minor">From <span className="is-vHiddenAt--medium+">(date)</span></label>
						// 			<div className="cp-FormField-holder">
						// 				<input id="txtDisplayCategories--dateFrom" name="txtDisplayCategories--dateFrom" type="date" className="cp-FormField-input" />
						// 			</div>
						// 		</div>
						// 		<div className="cp-FormField cp-FormField--minor cp-FormField--single">
						// 			<label for="txtDisplayCategories--dateTo" className="cp-FormField-label cp-FormField-label--single cp-FormField-label--minor">To <span className="is-vHiddenAt--medium+">(date)</span></label>
						// 			<div className="cp-FormField-holder">
						// 				<input id="txtDisplayCategories--dateTo" name="txtDisplayCategories--dateTo" type="date" className="cp-FormField-input" />
						// 			</div>
						// 		</div>
						// 	</div>
						// 	<h3 className="cp-DropdownMenu-menuHeading">Display</h3>
						// 	<div className="cp-DropdownMenu-menuSection cp-DropdownMenu-menuSection--columned">
						// 		<input id="ysnDisplayCategories--mineOnly" name="ysnDisplayCategories--mineOnly" type="checkbox" className="cp-Checkbox-input" checked />
						// 		<label for="ysnDisplayCategories--mineOnly" className="cp-Checkbox-label">Mine Only</label>
						// 		<input id="ysnDisplayCategories--published" name="ysnDisplayCategories--published" type="checkbox" className="cp-Checkbox-input" checked />
						// 		<label for="ysnDisplayCategories--published" className="cp-Checkbox-label">Published</label>
						// 		<input id="ysnDisplayCategories--draft" name="ysnDisplayCategories--draft" type="checkbox" className="cp-Checkbox-input" checked />
						// 		<label for="ysnDisplayCategories--draft" className="cp-Checkbox-label">Draft</label>
						// 		<input id="ysnDisplayCategories--submitted" name="ysnDisplayCategories--submitted" type="checkbox" className="cp-Checkbox-input" checked />
						// 		<label for="ysnDisplayCategories--submitted" className="cp-Checkbox-label">Submitted</label>
						// 		<input id="ysnDisplayCategories--declined" name="ysnDisplayCategories--declined" type="checkbox" className="cp-Checkbox-input" />
						// 		<label for="ysnDisplayCategories--declined" className="cp-Checkbox-label">Declined</label>
						// 	</div>
						// </div>
						_react2.default.createElement(
							'div',
							{ className: 'cp-DropdownMenu-menu Dropdown-fade-' + state },
							_react2.default.createElement(
								'div',
								{ className: 'cp-DropdownMenu-menuSection' },
								_react2.default.createElement(
									'div',
									{ className: 'cp-FormField cp-FormField--single cp-FormField--minor' },
									_react2.default.createElement(
										'label',
										{ 'for': 'displayCategories--user', className: 'cp-FormField-label cp-FormField-label--single cp-FormField-label--minor' },
										'Owner'
									),
									_react2.default.createElement(
										'div',
										{ className: 'cp-FormField-holder' },
										_react2.default.createElement('input', { id: 'displayCategories--user', name: 'displayCategories--user', type: 'text', className: 'cp-FormField-input' })
									)
								)
							),
							_react2.default.createElement(
								'h3',
								{ className: 'cp-DropdownMenu-menuHeading' },
								'Product'
							),
							_react2.default.createElement(
								'div',
								{ className: 'cp-DropdownMenu-menuSection cp-DropdownMenu-menuSection--columned' },
								_react2.default.createElement('input', { id: 'ysnDisplayCategories--mineOnly', name: 'ysnDisplayCategories--mineOnly', type: 'checkbox', className: 'cp-Checkbox-input', checked: true }),
								_react2.default.createElement(
									'label',
									{ 'for': 'ysnDisplayCategories--mineOnly', className: 'cp-Checkbox-label' },
									'CivicEngage'
								),
								_react2.default.createElement('input', { id: 'ysnDisplayCategories--published', name: 'ysnDisplayCategories--published', type: 'checkbox', className: 'cp-Checkbox-input', checked: true }),
								_react2.default.createElement(
									'label',
									{ 'for': 'ysnDisplayCategories--published', className: 'cp-Checkbox-label' },
									'CivicHR'
								),
								_react2.default.createElement('input', { id: 'ysnDisplayCategories--draft', name: 'ysnDisplayCategories--draft', type: 'checkbox', className: 'cp-Checkbox-input', checked: true }),
								_react2.default.createElement(
									'label',
									{ 'for': 'ysnDisplayCategories--draft', className: 'cp-Checkbox-label' },
									'CivicReady'
								),
								_react2.default.createElement('input', { id: 'ysnDisplayCategories--submitted', name: 'ysnDisplayCategories--submitted', type: 'checkbox', className: 'cp-Checkbox-input', checked: true }),
								_react2.default.createElement(
									'label',
									{ 'for': 'ysnDisplayCategories--submitted', className: 'cp-Checkbox-label' },
									'CivicRec'
								),
								_react2.default.createElement('input', { id: 'ysnDisplayCategories--declined', name: 'ysnDisplayCategories--declined', type: 'checkbox', className: 'cp-Checkbox-input' }),
								_react2.default.createElement(
									'label',
									{ 'for': 'ysnDisplayCategories--declined', className: 'cp-Checkbox-label' },
									'CivicClerk'
								)
							)
						)
					);
				}
			);
		};

		_this.state = {
			dropdownLabel: _this.props.title,
			isOpen: false
		};
		return _this;
	}

	return Filter;
}(_react.Component);

Filter.propTypes = {
	title: _propTypes2.default.string,
	id: _propTypes2.default.string.isRequired,
	onChange: _propTypes2.default.func,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({ enter: _propTypes2.default.number, exit: _propTypes2.default.number }), _propTypes2.default.number])
};
Filter.defaultProps = {
	title: 'Filter',
	transitionTimeout: 240,
	onChange: function onChange(e) {}
};
exports.default = Filter;