'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _jestMatchers = require('jest-matchers');

var _jestMatchers2 = _interopRequireDefault(_jestMatchers);

var _Pagination = require('./Pagination');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

it('Expects the pagination control to render nothing', function () {
        var data = {
                currentPage: 1,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 25,
                total: 1
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var items = wrapper.find('.Pagination__list__item');
        (0, _jestMatchers2.default)(items.length).toBe(0);
});

it('Expects the pagination control to render 1-8 and arrows', function () {
        var data = {
                currentPage: 2,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 8
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");

        var page2 = wrapper.find('#page_2');
        (0, _jestMatchers2.default)(page2.text()).toBe("2");
        (0, _jestMatchers2.default)(page2.type()).toBe("strong");

        var page3 = wrapper.find('#page_3');
        (0, _jestMatchers2.default)(page3.text()).toBe("3");

        var page4 = wrapper.find('#page_4');
        (0, _jestMatchers2.default)(page4.text()).toBe("4");

        var page5 = wrapper.find('#page_5');
        (0, _jestMatchers2.default)(page5.text()).toBe("5");

        var page6 = wrapper.find('#page_6');
        (0, _jestMatchers2.default)(page6.text()).toBe("6");

        var page7 = wrapper.find('#page_7');
        (0, _jestMatchers2.default)(page7.text()).toBe("7");

        var page8 = wrapper.find('#page_8');
        (0, _jestMatchers2.default)(page8.text()).toBe("8");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(false);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(false);
});

it('Expects the pagination control to render showing pages 1-5 and 99 and 1 is selected', function () {
        var data = {
                currentPage: 1,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 99
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");
        (0, _jestMatchers2.default)(page1.type()).toBe("strong");

        var page2 = wrapper.find('#page_2');
        (0, _jestMatchers2.default)(page2.text()).toBe("2");

        var page3 = wrapper.find('#page_3');
        (0, _jestMatchers2.default)(page3.text()).toBe("3");

        var page4 = wrapper.find('#page_4');
        (0, _jestMatchers2.default)(page4.text()).toBe("4");

        var page5 = wrapper.find('#page_5');
        (0, _jestMatchers2.default)(page5.text()).toBe("5");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(true);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(false);
});

it('Expects the pagination control to render showing pages 1-5 and 99 and 4 is selected', function () {
        var data = {
                currentPage: 4,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 99
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");

        var page2 = wrapper.find('#page_2');
        (0, _jestMatchers2.default)(page2.text()).toBe("2");

        var page3 = wrapper.find('#page_3');
        (0, _jestMatchers2.default)(page3.text()).toBe("3");

        var page4 = wrapper.find('#page_4');
        (0, _jestMatchers2.default)(page4.text()).toBe("4");
        (0, _jestMatchers2.default)(page4.type()).toBe("strong");

        var page5 = wrapper.find('#page_5');
        (0, _jestMatchers2.default)(page5.text()).toBe("5");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(false);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(false);
});

it('Expects the pagination control to render showing pages 3-7 and 99 and 5 is selected', function () {
        var data = {
                currentPage: 5,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 99
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");

        var page3 = wrapper.find('#page_3');
        (0, _jestMatchers2.default)(page3.text()).toBe("3");

        var page4 = wrapper.find('#page_4');
        (0, _jestMatchers2.default)(page4.text()).toBe("4");

        var page5 = wrapper.find('#page_5');
        (0, _jestMatchers2.default)(page5.text()).toBe("5");
        (0, _jestMatchers2.default)(page5.type()).toBe("strong");

        var page6 = wrapper.find('#page_6');
        (0, _jestMatchers2.default)(page6.text()).toBe("6");

        var page7 = wrapper.find('#page_7');
        (0, _jestMatchers2.default)(page7.text()).toBe("7");

        var page99 = wrapper.find('#page_99');
        (0, _jestMatchers2.default)(page99.text()).toBe("99");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(false);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(false);
});

it('Expects the pagination control to render showing pages 3-7 and 99 and 96 is selected', function () {
        var data = {
                currentPage: 96,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 99
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");

        var page95 = wrapper.find('#page_95');
        (0, _jestMatchers2.default)(page95.text()).toBe("95");

        var page96 = wrapper.find('#page_96');
        (0, _jestMatchers2.default)(page96.text()).toBe("96");
        (0, _jestMatchers2.default)(page96.type()).toBe("strong");

        var page97 = wrapper.find('#page_97');
        (0, _jestMatchers2.default)(page97.text()).toBe("97");

        var page98 = wrapper.find('#page_98');
        (0, _jestMatchers2.default)(page98.text()).toBe("98");

        var page99 = wrapper.find('#page_99');
        (0, _jestMatchers2.default)(page99.text()).toBe("99");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(false);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(false);
});

it('Expects the pagination control to render showing pages 3-7 and 99 and 99 is selected', function () {
        var data = {
                currentPage: 99,
                limit: 8,
                onPageSelect: function onPageSelect(page) {},
                pageSize: 1,
                total: 99
        };

        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Pagination.Pagination, {
                currentPage: data.currentPage,
                limit: data.limit,
                pageSize: data.pageSize,
                total: data.total
        }));

        var page1 = wrapper.find('#page_1');
        (0, _jestMatchers2.default)(page1.text()).toBe("1");

        var page95 = wrapper.find('#page_95');
        (0, _jestMatchers2.default)(page95.text()).toBe("95");

        var page96 = wrapper.find('#page_96');
        (0, _jestMatchers2.default)(page96.text()).toBe("96");

        var page97 = wrapper.find('#page_97');
        (0, _jestMatchers2.default)(page97.text()).toBe("97");

        var page98 = wrapper.find('#page_98');
        (0, _jestMatchers2.default)(page98.text()).toBe("98");

        var page99 = wrapper.find('#page_99');
        (0, _jestMatchers2.default)(page99.text()).toBe("99");
        (0, _jestMatchers2.default)(page99.type()).toBe("strong");

        var arrowPrevious = wrapper.find('#page_' + (data.currentPage - 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowPrevious.hasClass('is-inactive')).toBe(false);

        var arrowNext = wrapper.find('#page_' + (data.currentPage + 1) + '_arrow');
        (0, _jestMatchers2.default)(arrowNext.hasClass('is-inactive')).toBe(true);
});