'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Pill = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ALERT_TYPES = ['danger', 'default', 'info', 'primary', 'success', 'warning', 'danger-inverted', 'default-inverted', 'info-inverted', 'primary-inverted', 'success-inverted', 'warning-inverted'];

var Pill = exports.Pill = function (_Component) {
	_inherits(Pill, _Component);

	function Pill() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Pill);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Pill.__proto__ || Object.getPrototypeOf(Pill)).call.apply(_ref, [this].concat(args))), _this), _this.renderClearButton = function () {
			if (!_this.props.onClear) {
				return null;
			}
			return _react2.default.createElement(
				'button',
				{ type: 'button', onClick: _this.props.onClear, className: 'Pill__clear' },
				'\xD7'
			);
		}, _this.render = function () {
			var componentClass = (0, _classnames2.default)('Pill', 'Pill--' + _this.props.type, _this.props.className);

			var props = (0, _blacklist2.default)(_this.props, 'className', 'label', 'onClear', 'onClick', 'type');
			props.className = componentClass;

			return _react2.default.createElement(
				'div',
				props,
				_react2.default.createElement(
					'button',
					{ type: 'button', onClick: _this.props.onClick, className: 'Pill__label' },
					_this.props.label
				),
				_this.renderClearButton()
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return Pill;
}(_react.Component);

Pill.propTypes = {
	className: _propTypes2.default.string,
	label: _propTypes2.default.string.isRequired,
	onClear: _propTypes2.default.func,
	onClick: _propTypes2.default.func,
	type: _propTypes2.default.oneOf(ALERT_TYPES)
};
Pill.defaultProps = {
	type: 'default'
};
exports.default = Pill;