'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.RadioGroup = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioGroup = exports.RadioGroup = function (_Component) {
	_inherits(RadioGroup, _Component);

	function RadioGroup() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RadioGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RadioGroup.__proto__ || Object.getPrototypeOf(RadioGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getInitialState = function () {
			return {
				isValid: true,
				validationIsActive: _this.props.alwaysValidate
			};
		}, _this.componentDidMount = function () {
			if (_this.state.validationIsActive) {
				_this.validateInput(_this.props.value);
			}
		}, _this.componentWillReceiveProps = function (newProps) {
			if (_this.state.validationIsActive) {
				if (newProps.value !== _this.props.value && newProps.value !== _this._lastChangeValue && !newProps.alwaysValidate) {
					// reset validation state if the value was changed outside the component
					return _this.setState({
						isValid: true,
						validationIsActive: false
					});
				}
				_this.validateInput(newProps.value);
			}
		}, _this.handleChange = function (e) {
			_this._lastChangeValue = e.target.value;
			if (_this.props.onChange) _this.props.onChange(e.target.value);
		}, _this.handleBlur = function () {
			if (!_this.props.alwaysValidate) {
				_this.setState({ validationIsActive: false });
			}
			_this.validateInput(_this.props.value);
		}, _this.validateInput = function (value) {
			var newState = {
				isValid: true
			};
			if (_this.props.required && !value) {
				newState.isValid = false;
			}
			if (_this.props.required && value && !value.length) {
				newState.isValid = false;
			}
			if (!newState.isValid) {
				newState.validationIsActive = true;
			}
			_this.setState(newState);
		}, _this.render = function () {
			var self = _this;

			// props
			var props = (0, _blacklist2.default)(_this.props, 'alwaysValidate', 'label', 'onChange', 'options', 'required', 'requiredMessage', 'value', 'inline');

			// classes
			var componentClass = (0, _classnames2.default)('FormField', {
				'is-invalid': !_this.state.isValid
			}, _this.props.className);

			// validation message
			var validationMessage;
			if (!_this.state.isValid) {
				validationMessage = _react2.default.createElement(
					'div',
					{ className: 'form-validation is-invalid' },
					_this.props.requiredMessage
				);
			}

			// dynamic elements
			var componentLabel = _this.props.label ? _react2.default.createElement(
				'label',
				{ className: 'FormLabel' },
				_this.props.label
			) : null;

			// options
			var radios = _this.props.options.map(function (radio, i) {
				return _react2.default.createElement(
					'label',
					{ key: 'radio-' + i, className: 'Radio' },
					_react2.default.createElement('input', { value: radio.value, type: 'radio', onChange: self.handleChange, onBlur: self.handleBlur, name: self.props.name, className: 'Radio__input' }),
					_react2.default.createElement(
						'span',
						{ className: 'Radio__label' },
						radio.label
					)
				);
			});
			if (_this.props.inline) {
				radios = _react2.default.createElement(
					'div',
					{ className: 'inline-controls' },
					radios
				);
			}

			return _react2.default.createElement(
				'div',
				_extends({ className: componentClass }, props),
				componentLabel,
				radios,
				validationMessage
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return RadioGroup;
}(_react.Component);

RadioGroup.propTypes = {
	alwaysValidate: _propTypes2.default.bool,
	className: _propTypes2.default.string,
	inline: _propTypes2.default.bool,
	label: _propTypes2.default.string,
	onChange: _propTypes2.default.func.isRequired,
	options: _propTypes2.default.array.isRequired,
	required: _propTypes2.default.bool,
	requiredMessage: _propTypes2.default.string,
	value: _propTypes2.default.string
};
RadioGroup.defaultProps = {
	requiredMessage: 'This field is required'
};
exports.default = RadioGroup;