'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ResponsiveText = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

var _constants = require('./../../constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResponsiveText = exports.ResponsiveText = function (_Component) {
	_inherits(ResponsiveText, _Component);

	function ResponsiveText() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ResponsiveText);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ResponsiveText.__proto__ || Object.getPrototypeOf(ResponsiveText)).call.apply(_ref, [this].concat(args))), _this), _this.getInitialState = function () {
			return {
				windowWidth: typeof window !== 'undefined' ? window.innerWidth : 0
			};
		}, _this.componentDidMount = function () {
			if (typeof window !== 'undefined') {
				window.addEventListener('resize', _this.handleResize);
			}
		}, _this.componentWillUnmount = function () {
			if (typeof window !== 'undefined') {
				window.removeEventListener('resize', _this.handleResize);
			}
		}, _this.handleResize = function () {
			_this.setState({
				windowWidth: typeof window !== 'undefined' ? window.innerWidth : 0
			});
		}, _this.render = function () {
			var _this$props = _this.props,
			    hiddenXS = _this$props.hiddenXS,
			    hiddenSM = _this$props.hiddenSM,
			    hiddenMD = _this$props.hiddenMD,
			    hiddenLG = _this$props.hiddenLG,
			    visibleXS = _this$props.visibleXS,
			    visibleSM = _this$props.visibleSM,
			    visibleMD = _this$props.visibleMD,
			    visibleLG = _this$props.visibleLG;
			var windowWidth = _this.state.windowWidth;


			var text = void 0;

			// set widths / flex-basis
			if (windowWidth < _constants2.default.breakpoint.xs) {
				text = visibleXS || hiddenSM || hiddenMD || hiddenLG;
			} else if (windowWidth < _constants2.default.breakpoint.sm) {
				text = hiddenXS || visibleSM || hiddenMD || hiddenLG;
			} else if (windowWidth < _constants2.default.breakpoint.md) {
				text = hiddenXS || hiddenSM || visibleMD || hiddenLG;
			} else {
				text = hiddenXS || hiddenSM || hiddenMD || visibleLG;
			}

			var props = (0, _blacklist2.default)(_this.props, {
				'hiddenXS': true,
				'hiddenSM': true,
				'hiddenMD': true,
				'hiddenLG': true,
				'visibleXS': true,
				'visibleSM': true,
				'visibleMD': true,
				'visibleLG': true
			});

			return _react2.default.createElement(
				'span',
				props,
				text
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return ResponsiveText;
}(_react.Component);

ResponsiveText.propTypes = {
	hiddenLG: _propTypes2.default.string,
	hiddenMD: _propTypes2.default.string,
	hiddenSM: _propTypes2.default.string,
	hiddenXS: _propTypes2.default.string,
	visibleLG: _propTypes2.default.string,
	visibleMD: _propTypes2.default.string,
	visibleSM: _propTypes2.default.string,
	visibleXS: _propTypes2.default.string
};
exports.default = ResponsiveText;