'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SegmentedControl = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SegmentedControl = exports.SegmentedControl = function (_Component) {
	_inherits(SegmentedControl, _Component);

	function SegmentedControl() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, SegmentedControl);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SegmentedControl.__proto__ || Object.getPrototypeOf(SegmentedControl)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (value) {
			_this.props.onChange(value);
		}, _this.render = function () {
			_this.props.className = (0, _classnames2.default)('SegmentedControl', 'SegmentedControl--' + _this.props.type, {
				'SegmentedControl--equal-widths': _this.props.equalWidthSegments
			}, _this.props.className);

			return _react2.default.createElement(
				'div',
				_this.props,
				_this.props.options.map(function (op) {

					var buttonClassName = (0, _classnames2.default)('SegmentedControl__button', {
						'is-selected': op.value === _this.props.value
					});

					return _react2.default.createElement(
						'span',
						{ key: 'option-' + op.value, className: 'SegmentedControl__item' },
						_react2.default.createElement(
							'button',
							{ type: 'button', onClick: function onClick() {
									return _this.props.onChange(op.value);
								}, className: buttonClassName },
							op.label
						)
					);
				})
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return SegmentedControl;
}(_react.Component);

SegmentedControl.propTypes = {
	className: _propTypes2.default.string,
	equalWidthSegments: _propTypes2.default.bool,
	onChange: _propTypes2.default.func.isRequired,
	options: _propTypes2.default.array.isRequired,
	type: _propTypes2.default.oneOf(['default', 'muted', 'danger', 'info', 'primary', 'success', 'warning']),
	value: _propTypes2.default.string
};
SegmentedControl.defaultProps = {
	type: 'default'
};
exports.default = SegmentedControl;