'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Tab = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Based on code from: // Based on code from https://medium.com/trisfera/a-simple-react-tabs-component-47cac2cfbb5

var Tab = exports.Tab = function Tab(props) {
    return _react2.default.createElement(
        'li',
        { className: 'cp-Tabs-tab ' + (props.isActive ? 'is-active' : '') },
        _react2.default.createElement(
            'a',
            { className: 'cp-Tabs-link',
                onClick: function onClick(event) {
                    event.preventDefault();
                    props.onClick(props.tabIndex);
                },
                onKeyPress: function onKeyPress(event) {
                    if (event.key === "Enter") {
                        event.preventDefault();
                        props.onClick(props.tabIndex);
                    }
                },
                tabindex: '0' },
            props.title,
            _react2.default.createElement(
                'svg',
                { className: 'cp-Tabs-linkArrow--inactive' },
                _react2.default.createElement('use', { xlinkHref: '#iconArrow--right' })
            )
        )
    );
};

Tab.propTypes = {
    onClick: _propTypes2.default.func,
    tabIndex: _propTypes2.default.number,
    isActive: _propTypes2.default.bool,
    title: _propTypes2.default.string
};

exports.default = Tab;